require 'octokit'

module GitHubPr
	class Poster
		def initialize(token)
			@token = token
		end

		def post(options)
			client = Octokit::Client.new(:access_token => @token.get())
			begin
				postPrivate(client, options)
			rescue Octokit::Unauthorized
				puts 'Unauthorized error, revoking access token'
				client = Octokit::Client.new(:access_token => @token.get(regenerate: true))
				postPrivate(client, options)
			end
		end
		def postPrivate(client, options)
			repo_url = options[:url]
			repo_url = Poster.repo_url() if repo_url.nil?
			repo = cut_scheme_and_host(repo_url)
			pull_request = client.create_pull_request(repo, 
				options[:base],
				options[:feature], 
				options[:title], nil)
			client.post("/repos/#{repo}/issues/#{pull_request['number']}/assignees", 
				assignees: [options[:assign]])
		end

	  # https://github.com/user/reponame cutting path user/reponame
	  def cut_scheme_and_host(url)
	  	URI::parse(url).path[1..-1]
	  end
	  def self.repo_url
	  	`git config --get remote.origin.url`.chomp
	  end
	end
end